unit Win;

interface

{$I share.inc}

uses Kol, Share, ShellAPI, Windows, Messages, Debug, hiHintManager, WinLayout;

type
  KOLChar = char;
  TIControlManager = record
    ctrlpoint:function:pointer of object;
    getclass:function:pointer of object;
  end;
  IControlManager = ^TIControlManager;

type
  THIWin = class(TDebug)
  protected
    FParent: PControl;
    Split: PControl;

    Guid: integer;
    NoKill: boolean;
    OldMes: TOnMessage;
    OldPaint: TOnPaint;
    OldErase: TOnPaint;
    Ms: TMouseEventData;
    Back: integer; //!!! KeyPreview
    hid: pointer;
    chkey: pointer;
 
    cp: TIControlManager;
    fHint:IHintManager;
    fLayout:IWinLayout;

    fOnPaint: THI_Event;
    fOnErase: THI_Event;
    fOnSplitUp:THI_Event;
    fOnMouseEnter:THI_Event;
    fOnMouseLeave:THI_Event;

    _IsConnectMouseEnter: boolean;
    _IsConnectMouseLeave: boolean;
    _IsConnectOnPaint: boolean;
    _IsConnectOnErase: boolean;
    _IsConnectOnSplitUp: boolean;

    fDefTop: integer;
    fDefLeft: integer;
    fDefRight: integer;
    fDefBottom: integer;
    fDefWidth: integer;
    fDefHeight: integer;

    procedure InitAnchorsPos;
    function ctrlpoint: pointer;
    function getclass: pointer;
    procedure KeyDown(Sender: PControl; var Key: Longint; Shift: DWORD); //!!! KeyPreview
    procedure KeyUp(Sender: PControl; var Key: Longint; Shift: DWORD); //!!! KeyPreview
    procedure KeyChar(Sender: PControl; var Key: KOLChar; Shift: DWORD); //!!! KeyPreview
    procedure _OnKeyDown(Sender: PControl; var Key: Longint; Shift: DWORD);  virtual; //!!! KeyPreview
    procedure _OnKeyUp(Sender: PControl; var Key: Longint; Shift: DWORD); virtual; //!!! KeyPreview
    procedure _OnKeyChar(Sender: PControl; var Key: KOLChar; Shift: DWORD);  virtual; //!!! KeyPreview
    procedure _OnMouseDown(Sender: PControl; var Mouse: TMouseEventData); virtual;
    procedure _OnMouseMove(Sender: PControl; var Mouse: TMouseEventData); virtual;
    procedure _OnMouseEnter( Sender: PObj ); virtual;
    procedure _OnMouseLeave( Sender: PObj ); virtual;
    procedure _OnMouseUp(Sender: PControl; var Mouse: TMouseEventData); virtual;
    procedure _OnMouseWheel(Sender: PControl; var Mouse: TMouseEventData); virtual;//!!!
    function  _OnMessage( var Msg: TMsg; var Rslt: Integer ): Boolean; virtual;
    procedure _OnDblClick(Sender: PControl; var Mouse: TMouseEventData); virtual;
    procedure _OnDestroy(Sender: PObj); virtual;
    procedure _OnResize(Obj: PObj);virtual;
    procedure _OnShow(Obj: PObj); virtual;
    procedure _OnHide(Obj: PObj); virtual;
    procedure _OnSplitUp(Sender: PControl; var Mouse: TMouseEventData);
    procedure _OnPaint(Sender: PControl; DC: HDC);
    procedure _OnEraseBkgnd(Sender: PControl; DC: HDC);
    procedure SetOnPaint(Ev: THI_Event);
    procedure SetOnErase(Ev: THI_Event);
    procedure TrackMouseEvnt(Sender: PControl; Flags :DWORD);
    procedure SetOnSplitUp(Ev: THI_Event);
    procedure SetLayout(Value: IWinLayout);
    procedure SetHintManager(Value: IHintManager);
    procedure SetMouseEnter(Ev: THI_Event);
    procedure SetMouseLeave(Ev: THI_Event);
  public
    Control: PControl;
    ManFlags: cardinal;

    _prop_Name: string;
    _prop_Left: integer;
    _prop_Top: integer;
    _prop_Width: integer;
    _prop_Height: integer;
    _prop_Align: TControlAlign;
    _prop_TabOrder: integer;
    _prop_Color: TColor;
    _prop_Ctl3D: byte;
    _prop_Hint: string;
    _prop_Font: TFontRec;
    _prop_ParentFont: boolean;
    _prop_Transparent: boolean;
    _prop_Visible: boolean;
    _prop_Enabled: boolean;
    _prop_Cursor: integer;
    _prop_MouseCapture: boolean;
    _prop_Flat: boolean;
    _prop_KeyPreview: boolean; //!!! KeyPreview
    _prop_WidthScale: integer;
    _prop_HeightScale: integer;

//-  Splitter
    _prop_ModeSp: TNewSpl;
    _prop_SizeSp: integer;
    _prop_ColorSp: TColor;
    _prop_MinOwn: integer;
    _prop_MinRest: integer;
    _prop_WinStyle: byte;

//-  Margin
    _prop_MarginLeft: integer;
    _prop_MarginTop: integer;
    _prop_MarginRight: integer;
    _prop_MarginBottom: integer;
    _prop_Border: integer;
     
//-  Anchors
    _prop_akLeft: boolean;
    _prop_akTop: boolean;
    _prop_akRight: boolean;
    _prop_akBottom: boolean;

//- Constraints
    _prop_MinWidth: integer;
    _prop_MinHeight: integer;
    _prop_MaxWidth: integer;
    _prop_MaxHeight: integer;
     
    _event_onKeyDown: THI_Event;
    _event_onKeyUp: THI_Event;
    _event_onChar: THI_Event; //!!! KeyPreview
    _event_onMouseDown: THI_Event;
    _event_onMouseMove: THI_Event;
    _event_onMouseUp: THI_Event;
    _event_onMouseWheel: THI_Event;
    _event_onSetFocus: THI_Event;
    _event_onKillFocus: THI_Event;
    _event_onDblClick: THI_Event;
    _event_onResize: THI_Event;
    _event_onShow: THI_Event;
    _event_onHide: THI_Event;
    _event_onMove: THI_Event;

    _data_WidthControls: THI_Event;
    _data_HeightControls: THI_Event;

    constructor Create(Parent: PControl);
    destructor Destroy; override;
    procedure Init; virtual;

    function getInterfaceControlManager: IControlManager; virtual;

    procedure _work_doKeyPreview(var Data: TData; Index: word); //!!! KeyPreview
    procedure _work_doVisible(var Data: TData; Index: word);
    procedure _work_doEnabled(var Data: TData; Index: word);
    procedure _work_doHint(var Data: TData; Index: word);
    procedure _work_doLeft(var Data: TData; Index: word);
    procedure _work_doTop(var Data: TData; Index: word);
    procedure _work_doWidth(var Data: TData; Index: word);
    procedure _work_doHeight(var Data: TData; Index: word);
    procedure _work_doColor(var Data: TData; Index: word);
    procedure _work_doCursor(var Data: TData; Index: word);
    procedure _work_doSendToBack(var Data: TData; Index: word);
    procedure _work_doBringToFront(var Data: TData; Index: word);
    procedure _work_doCenterPos(var Data: TData; Index: word);
    procedure _work_doFont(var Data: TData; Index: word);
    procedure _work_doAlign(var Data: TData; Index: word);
    procedure _work_doSetFocus(var Data: TData; Index: word);
    procedure _work_doKeyBack(var Data: TData; Index: word); //!!! KeyPreview
    procedure _var_Handle(var Data: TData; Index: word);
    procedure _var_PHandle(var Data: TData; Index: word);
    procedure _var_MouseX(var Data: TData; Index: word);
    procedure _var_MouseY(var Data: TData; Index: word);
    procedure _var_Left(var Data: TData; Index: word);
    procedure _var_Top(var Data: TData; Index: word);
    procedure _var_Width(var Data: TData; Index: word);
    procedure _var_Height(var Data: TData; Index: word);
    procedure _var_Position(var Data: TData; Index: word);

    property  _event_onSplitUp: THI_Event write SetOnSplitUp;
    property  _event_onPaint: THI_Event read fOnPaint write SetOnPaint;
    property  _event_onEraseBkgnd: THI_Event read fOnErase write SetOnErase;
    property  _event_onMouseEnter: THI_Event read fonMouseEnter write SetMouseEnter;
    property  _event_onMouseLeave: THI_Event read fonMouseLeave write SetMouseLeave;

    property _prop_Layout: IWinLayout write SetLayout;
    property _prop_HintManager: IHintManager read fHint write SetHintManager;
end;

var  ListOfNameControls: PStrListEx;

const
  BorderStyle_Mask = not(WS_CAPTION or WS_THICKFRAME or WS_MAXIMIZEBOX or WS_MINIMIZEBOX);
  BorderStyle_Set: array[0..9] of dword =(0,
      WS_CAPTION or WS_MINIMIZEBOX,
      WS_CAPTION or WS_THICKFRAME or WS_MAXIMIZEBOX or WS_MINIMIZEBOX,
      WS_CAPTION,
      WS_CAPTION,
      WS_CAPTION or WS_THICKFRAME,
      0,
      WS_THICKFRAME,
      0,
      WS_THICKFRAME
  );
  BorderStyle_ExMask = not(WS_EX_DLGMODALFRAME or WS_EX_WINDOWEDGE or WS_EX_TOOLWINDOW or WS_EX_CLIENTEDGE);
  BorderStyle_ExSet: array[0..9] of dword =(0,0,0,
      WS_EX_WINDOWEDGE,
      WS_EX_TOOLWINDOW,
      WS_EX_TOOLWINDOW,
      WS_EX_DLGMODALFRAME,
      WS_EX_TOOLWINDOW,
      WS_EX_CLIENTEDGE or WS_EX_DLGMODALFRAME,
      WS_EX_CLIENTEDGE
  );
  WinStyle_ExMask = not(WS_EX_DLGMODALFRAME or WS_EX_CLIENTEDGE or WS_EX_LTRREADING or WS_EX_STATICEDGE);
  WinStyle_ExSet: array[0..4] of dword =(
      WS_EX_CLIENTEDGE,
      WS_EX_LTRREADING,
      WS_EX_STATICEDGE,
      WS_EX_DLGMODALFRAME,
      WS_EX_CLIENTEDGE or WS_EX_DLGMODALFRAME
  );

implementation

var
  defHint: THIHintManager;

//-------------------------------------------------------------------------------------------------

function TrackMouseEvent(var EventTrack: TTrackMouseEvent): BOOL; stdcall; external user32 name 'TrackMouseEvent';

//-------------------------------------------------------------------------------------------------

procedure THIWin.TrackMouseEvnt;
var
  t_MouseEvent: TTrackMouseEvent;
begin
  t_MouseEvent.cbSize := SizeOf(TTrackMouseEvent);
  t_MouseEvent.dwFlags := Flags;
  t_MouseEvent.hwndTrack := Sender.GetWindowHandle;
  t_MouseEvent.dwHoverTime := HOVER_DEFAULT;
  TrackMouseEvent(t_MouseEvent);
end;

function THIWin.getInterfaceControlManager;
begin
  Result := @cp;
end;

function THIWin.ctrlpoint;
begin
  Result := Control;
end;

function THIWin.getclass;
begin
  Result := Self;
end;

constructor THIWin.Create;
begin
  inherited Create;
  FParent := Parent;
  if Parent <> nil then _prop_Color := Parent.Color;

  _prop_Ctl3D := 2;
  _prop_Visible := true;
  _prop_Enabled := true;
  _prop_KeyPreview := true; //!!! KeyPreview
  _prop_MouseCapture := false;

  _IsConnectMouseEnter := false;
  _IsConnectMouseLeave := false;
  _IsConnectOnPaint    := false;
  _IsConnectOnErase    := false;
  _IsConnectOnSplitUp  := false;
end;

destructor THIWin.Destroy;
begin
  if fLayout <> nil then 
    ExplodeLayout(FLayout, Control);
     
  if not NoKill then
  begin
    Split.Free;
    Control.Visible := false; //for Global_Align(Parent)
    Control.Free;
  end;
   
  if hid <> nil then fHint.free(hid);
  if ListOfNameControls.IndexOfObj(Control) <> -1 then
    ListOfNameControls.Delete(ListOfNameControls.IndexOfObj(Control));
  inherited;
end;

procedure THIWin._onShow;
begin
  Sendmessage(Control.Handle, US_SHOW, 0, 0);
end;

procedure THIWin._onHide;
begin
  Sendmessage(Control.Handle, US_HIDE, 0, 0);
end;

procedure THIWin._OnDestroy;
begin
  NoKill := true;
end;

procedure THIWin.InitAnchorsPos;
begin
  fDefTop    := Control.Top;
  fDefLeft   := Control.Left;
  fDefRight  := Control.Parent.Width - (Control.Left + Control.Width);
  fDefBottom := Control.Parent.Height - (Control.Top + Control.Height);
  fDefWidth  := Control.Width;
  fDefHeight := Control.Height;
end;

procedure THIWin.Init;
const
  wpFlag = SWP_NOSIZE or SWP_NOMOVE or SWP_NOACTIVATE or SWP_NOOWNERZORDER or SWP_HIDEWINDOW;
begin
  with Control{$ifndef F_P}^{$endif} do
  begin
    cp.ctrlpoint := ctrlpoint;
    cp.getclass := getclass;
    Color := _prop_Color;
    SetPosition(_prop_Left, _prop_Top);
    SetSize(_prop_Width, _prop_Height);

    if _prop_Ctl3D < 2 then
      Ctl3D := _prop_Ctl3D = 0;

    Transparent := _prop_Transparent;
    Enabled := _prop_Enabled;
    CursorLoad(0, MakeIntResource(_prop_Cursor));

    if _prop_Flat then
      Style := Style or BS_FLAT;

    if _prop_ParentFont then
      Font.Assign(Parent.Font)
    else
    begin
      Font.Color := _prop_Font.Color;
      SetFont(Font, _prop_Font.Style);
      Font.FontName :=  _prop_Font.Name;
      Font.FontHeight := _hi_SizeFnt(_prop_Font.Size);
      Font.FontCharset := _prop_Font.CharSet;
//!!!  andrestudio
         Font.FontQuality := fqAntialiased;
         Canvas.Font.FontQuality := fqAntialiased;
    end;

    if _prop_TabOrder > 0 then
    begin
      Style := Style or WS_TABSTOP;
      LookTabKeys := [tkTab];
      TabOrder := _prop_TabOrder;
    end
    else
      TabStop := _prop_TabOrder = 0;

    OldMes        :=  OnMessage;
    OnMouseDown   := _OnMouseDown;
    OnMouseMove   := _OnMouseMove;
    OnMouseUp     := _OnMouseUp;
    OnMouseWheel  := _OnMouseWheel;
    OnMouseDblClk := _OnDblClick;
    OnMessage     := _OnMessage;
    OnDestroy     := _OnDestroy;
    OnKeyDown     := KeyDown; //!!! KeyPreview
    OnKeyUp       := KeyUp;   //!!! KeyPreview
    OnChar        := KeyChar; //!!! KeyPreview
    OnResize      := _OnResize;
    OnShow        := _OnShow;
    OnHide        := _OnHide;

    Align := _prop_Align;
    SetWindowPos(GetWindowHandle, HWND_TOP, 0, 0, 0, 0, wpFlag);
    Visible := _prop_Visible;
    CreateWindow;

    if Assigned(_prop_ModeSp) then
    begin
      Split := _prop_ModeSp(FParent, _prop_MinOwn, _prop_MinRest, _prop_ColorSp, _prop_SizeSp);
      SetWindowPos(Split.GetWindowHandle, HWND_TOP, 0, 0, 0, 0, wpFlag);
      case Align of
        caTop,caBottom:
        begin
          Height := Height - (_prop_SizeSp + FParent.Border);
          Split.Visible := _prop_Visible;
        end;
        
        caLeft,caRight:
        begin
          Width := Width - (_prop_SizeSp + FParent.Border);
          Split.Visible := _prop_Visible;
        end;
        else Split.Visible := false;
      end; // Case

      Split.CreateWindow;
    end;

    if _prop_Ctl3D = 0 then
      if (_prop_WinStyle > 0) and (_prop_WinStyle < cardinal(Length(WinStyle_ExSet))) then
        Control.ExStyle := WinStyle_ExSet[_prop_WinStyle];

    MarginLeft   := _prop_MarginLeft;
    MarginTop    := _prop_MarginTop;
    MarginRight  := _prop_MarginRight;
    MarginBottom := _prop_MarginBottom;
    Border       := _prop_Border;

    if _prop_MinWidth >= Width then
      MinWidth := Width
    else
      MinWidth := _prop_MinWidth; 

    if _prop_MinHeight >= Height then
      MinHeight := Height
    else
      MinHeight := _prop_MinHeight;
      
    if (_prop_MaxWidth <= Width) and (_prop_MaxWidth <> 0) then
      MaxWidth := Width
    else
      MaxWidth := _prop_MaxWidth;

    if (_prop_MaxHeight <= Height) and (_prop_MaxHeight <> 0) then
      MaxHeight := Height
    else
      MaxHeight := _prop_MaxHeight;

    InitAnchorsPos;
  end;

  if _prop_Name <> '' then ListOfNameControls.AddObject(LowerCase(_prop_Name), LongInt(Control));
end;

procedure THIWin.SetMouseEnter(Ev:THI_Event);
begin
  //  :
  //  - ,     WM_PAINT  ,    MouseEnter;
  //      ,  MouseEvent     +    
  fonMouseEnter := ev;
  if _IsConnectMouseEnter then exit;
  Control.onMouseEnter  := _onMouseEnter;
  _IsConnectMouseEnter := true;
end;

procedure THIWin.SetMouseLeave(Ev:THI_Event);
begin
  fonMouseLeave := ev;
  if _IsConnectMouseLeave then exit;
  Control.onMouseLeave  := _onMouseLeave;
  _IsConnectMouseLeave := true;
end;

procedure THIWin._onDblClick;
begin
  Sendmessage(Control.Handle, US_MOUSEDBLCLK, 0, integer(Mouse.Button)-1);
end;

procedure THIWin._work_doColor;
begin
  Control.Color := ToInteger(Data);
end;

procedure THIWin._work_doCursor;
begin
  Control.CursorLoad(0, MakeIntResource(ToInteger(Data)));
end;

procedure THIWin._work_doVisible;
begin
  Control.Visible := ReadBool(Data);
  if (Split = nil) or (Control.Align in [caNone, caClient]) then exit;
  Split.Visible := Control.Visible;
end;

procedure  THIWin._work_doEnabled;
begin
  Control.Enabled := ReadBool(Data);
end;

procedure THIWin._work_doHint;
begin
  if Assigned(_prop_HintManager) then _prop_HintManager.hint(hid, ToString(Data));
end;

procedure THIWin._work_doLeft;
begin
  Control.Left := ToInteger(Data);
end;

procedure THIWin._work_doTop;
begin
  Control.Top := ToInteger(Data);
end;

procedure THIWin._work_doWidth;
begin
  Control.Width := ToInteger(Data);
end;

procedure THIWin._work_doHeight;
begin
  Control.Height := ToInteger(Data);
end;

procedure THIWin._work_doSendToBack;
begin
  Control.SendToBack;
end;

procedure THIWin._work_doBringToFront;
begin
  Control.BringToFront;
end;

procedure THIWin._work_doCenterPos;
var
  H: THandle;
  R: TRect;
begin
  if Control.IsForm then
  begin
    if not ((Control.Parent <> nil) and
            (Control.Parent.IsForm) and
             GetWindowRect(Control.Parent.Handle, R)) then
    begin
      R.Left := 0;
      R.Right := ScreenWidth;
      R.Top := 0;
      R.Bottom := ScreenHeight;        
    end;
  end
  else
  begin
    H := GetParent(Control.Handle);
    if (H = 0) or (not GetClientRect(H, R)) then exit;
  end;

  Control.Left := R.Left + ((R.Right - R.Left) - Control.Width) div 2;
  Control.Top := R.Top + ((R.Bottom - R.Top) - Control.Height) div 2;
end;

procedure THIWin._work_doFont;
begin
  if _IsFont(Data) then
  begin
    _prop_Font := pfontrec(Data.idata)^; //+  

    with pfontrec(Data.idata)^ do
    begin
      Control.Font.Color := Color;
      SetFont(Control.Font,Style);
      Control.Font.FontName :=  Name;
      Control.Font.FontHeight := _hi_SizeFnt(Size);
      Control.Font.FontCharset := CharSet;
    end;
  end;
end;

procedure THIWin._work_doAlign;
begin
  Control.Align := TControlAlign(ToInteger(Data));
  if Split = nil then exit;
  case Control.Align of
    caLeft, caRight:
    begin
      Split.Cursor := LoadCursor(0, IDC_SIZEWE);
      Split.Visible := Control.Visible;
    end;

    caTop, caBottom:
    begin
      Split.Cursor := LoadCursor(0, IDC_SIZENS);
      Split.Visible := Control.Visible;
    end;
    else Split.Visible := false;
  end; // Case

  Split.Align := Control.Align;
  Split.SetSize(_prop_SizeSp, _prop_SizeSp);
end;

procedure THIWin._onPaint;
begin
  if Assigned(OldPaint) then OldPaint(Sender, DC);
  Sendmessage(Control.Handle, US_PAINT, 0, integer(DC));
end;

procedure THIWin.SetOnPaint;
begin
  fOnPaint := Ev;
  if _IsConnectOnPaint then exit; 
  OldPaint := Control.OnPaint;
  Control.OnPaint := _OnPaint;
  _IsConnectOnPaint := true;
end;

procedure THIWin._onEraseBkgnd;
begin
  if Assigned(OldErase) then OldErase(Sender, DC);
  Sendmessage(Control.Handle, US_ERASEBKGND, 0, integer(DC));
end;

procedure THIWin.SetOnErase;
begin
  fOnErase := Ev;
  if _IsConnectOnErase then exit; 
  OldErase := Control.OnEraseBkgnd;
  Control.OnEraseBkgnd := _onEraseBkgnd;
  _IsConnectOnErase := true;
end;

procedure THIWin._onSplitUp;
begin
  Sendmessage(Control.Handle, US_SPLITUP, 0, 0);
end;

procedure THIWin.SetOnSplitUp;
begin
  if (Split = nil) then exit;
  fOnSplitUp := Ev;
  if _IsConnectOnSplitUp then exit;  
  Split.onMouseUp := _onSplitUp;
  _IsConnectOnSplitUp := true;
end;

procedure THIWin.SetLayout;
begin
  if Value <> nil then
    Value.addControl(Control, _prop_WidthScale, _prop_HeightScale);
  fLayout := Value;  
end;

procedure THIWin.SetHintManager;
begin
  if Value <> nil then
  begin
    if not _IsConnectMouseEnter then
      Control.onMouseEnter := _onMouseEnter;
    if not _IsConnectMouseLeave then       
      Control.onMouseLeave := _onMouseLeave;
  end
  else 
    if _prop_Hint = '' then
      exit
    else
      Value := defHint.getInterfaceHint;
  hid := Value.init(Control.GetWindowHandle);
  Value.hint(hid, _prop_Hint);
  fHint := Value; 
end;

procedure THIWin._work_doSetFocus;
begin
  Control.Focused := true;
end;

procedure THIWin._var_Handle;
begin
  dtInteger(Data, Control.GetWindowHandle);
end;

procedure THIWin._var_PHandle;
begin
  dtInteger(Data, integer(Control) );
end;

procedure THIWin._onMouseDown;
begin
  Ms := Mouse;
  Sendmessage(Control.Handle, US_MOUSEDOWN, 0, integer(Ms.Button) - 1);

  if _prop_MouseCapture then
  begin
    ReleaseCapture;
    SetCapture(Control.Handle);
  end;
end;

procedure THIWin._onMouseMove;
var
  b: smallint;
begin
  if Assigned(_prop_HintManager) then _prop_HintManager.move(hid, Ms.X, Ms.Y);
  case Ms.Shift of
    1:   b :=  0;
    2:   b :=  1;
    16:  b :=  2;
    else b := -1;
  end;
  Ms := Mouse;
  Sendmessage(Control.Handle,US_MOUSEMOVE, 0, b);
end;

procedure THIWin._onMouseUp;
begin
  Ms := Mouse;
  Sendmessage(Control.Handle, US_MOUSEUP, 0, integer(Ms.Button) - 1);
  if _prop_MouseCapture then ReleaseCapture;
end;

procedure THIWin._onMouseWheel;
begin
  Ms := Mouse;
  Sendmessage(Control.Handle, US_MOUSEWHEEL, 0, smallint(Ms.Shift shr 16));
end;

procedure THIWin._var_MouseX;
begin
  dtInteger(Data,Ms.X);
end;

procedure THIWin._var_MouseY;
begin
  dtInteger(Data,Ms.Y);
end;

procedure THIWin._var_Left;
begin
  dtInteger(Data,Control.Left);
end;

procedure THIWin._var_Top;
begin
  dtInteger(Data,Control.Top);
end;

procedure THIWin._var_Width;
begin
  dtInteger(Data,Control.Width)
end;

procedure THIWin._var_Height;
begin
  dtInteger(Data,Control.Height)
end;

procedure THIWin._var_Position;
begin
  dtInteger(Data, Control.SelStart);
end;

function THIWin._onMessage;
var
  P: PWindowPos;
  dt: TData;
  sz, i: integer;
begin
  case Msg.message of

    WM_WINDOWPOSCHANGING:
    begin
      P := Pointer(Msg.lParam);
      if (P.flags and SWP_NOSIZE) = 0 then
      begin
        sz := Control.Height;
        if P.cy <> sz then
        begin
          dtInteger(dt, P.cy - sz);
          _ReadData(dt,_data_HeightControls);
          if _isInteger(dt) then P.cy := sz + ToInteger(dt);
        end;
        sz := Control.Width;
        if P.cx <> sz then
        begin
          dtInteger(dt, P.cx - sz);
          _ReadData(dt, _data_WidthControls);
          if _isInteger(dt) then P.cx := sz + ToInteger(dt);
        end;
      end;
    end;

    WM_WINDOWPOSCHANGED:
    begin
      if (Control.MinWidth  <> 0) and (Control.Width  < Control.MinWidth)  then
        Control.Width  := Control.MinWidth;
      if (Control.MaxWidth  <> 0) and (Control.Width  > Control.MaxWidth)  then
        Control.Width  := Control.MaxWidth;
      if (Control.MinHeight <> 0) and (Control.Height < Control.MinHeight) then
        Control.Height := Control.MinHeight;
      if (Control.MaxHeight <> 0) and (Control.Height > Control.MaxHeight) then
        Control.Height := Control.MaxHeight;

      if (Control.ChildCount <> 0) and (fLayout = nil) then 
        for i := 0 to Control.ChildCount - 1 do
          if (Control.Children[i].Align = caNone) then
            Sendmessage(Control.Children[i].Handle, US_SETANCHORS, 0, 0);

      Control.Update;  //        
    end;

    WM_SETFOCUS :
      Sendmessage(Control.Handle, US_SETFOCUS, 0, 0);
    WM_KILLFOCUS:
      Sendmessage(Control.Handle, US_KILLFOCUS, 0, 0);
    WM_MOVE:
      Sendmessage(Control.Handle, US_MOVE, 0, 0);
//
//!!!   
//
    US_KEYUP:
      _hi_onEvent(_event_onKeyUp, Msg.lparam);
    US_KEYDOWN:
      _hi_onEvent(_event_onKeyDown, Msg.lparam);
    US_CHAR:
      _hi_onEvent(_event_onChar, string(Msg.lparam));
    US_SHOW:
      _hi_onEvent(_event_onShow);
    US_HIDE:
      _hi_onEvent(_event_onHide);
    US_RESIZE:
      _hi_onEvent(_event_onResize);
    US_MOUSEDOWN:
      _hi_onEvent(_event_onMouseDown, Msg.lparam);
    US_MOUSEMOVE:
      _hi_onEvent(_event_onMouseMove, Msg.lparam);
    US_MOUSEUP:
      _hi_onEvent(_event_onMouseUp, Msg.lparam);
    US_MOUSEWHEEL:
      _hi_onEvent(_event_onMouseWheel, Msg.lparam);
    US_MOVE:
      _hi_onEvent(_event_onMove);
    US_PAINT:
      _hi_onEvent(fOnPaint, Msg.lparam);  
    US_ERASEBKGND:
      _hi_onEvent(fOnErase, Msg.lparam);
    US_MOUSEDBLCLK:
      _hi_onEvent(_event_onDblClick, Msg.lparam);
    US_MOUSEENTER:
      _hi_onEvent(fOnMouseEnter);  
    US_MOUSELEAVE:
      _hi_onEvent(fOnMouseLeave);
    US_SETFOCUS:
      _hi_onEvent(_event_onSetFocus);
    US_KILLFOCUS:
      _hi_onEvent(_event_onKillFocus);
    US_SPLITUP:
      _hi_onEvent(fOnSplitUp);
//
//!!!   Anchors  andrestudio
//
    US_SETANCHORS:
    begin
      if _prop_akRight then
        if not _prop_akLeft then
          SetWindowPos(Control.Handle, 0, Control.Parent.Width - (fDefWidth + fDefRight),
                       Control.Top, fDefWidth, Control.Height, SWP_NOZORDER)
        else
          SetWindowPos(Control.Handle, 0, fDefLeft, Control.Top,
                       Control.Parent.Width - (fDefLeft + fDefRight), Control.Height, SWP_NOZORDER);

      if _prop_akBottom then
        if not _prop_akTop then
          SetWindowPos(Control.Handle, 0, Control.Left,
                       Control.Parent.Height - (fDefHeight + fDefBottom), Control.Width,
                       fDefHeight, SWP_NOZORDER)
        else
          SetWindowPos(Control.Handle, 0, Control.Left,
                       Control.Top, Control.Width, Control.Parent.Height - (fDefTop + fDefBottom),
                       SWP_NOZORDER);

    end;
  end; // Case
  
  Result := _hi_OnMessage(OldMes, Msg, Rslt);
end;

procedure THIWin._onMouseEnter;
begin
  if Assigned(_prop_HintManager) then _prop_HintManager.show(hid);
  Sendmessage(Control.Handle, US_MOUSEENTER, 0, 0);
end;

procedure THIWin._onMouseLeave;
begin
  if Assigned(_prop_HintManager) then _prop_HintManager.hide(hid);
  Sendmessage(Control.Handle, US_MOUSELEAVE, 0, 0);
end;

procedure THIWin._work_doKeyPreview; //!!! KeyPreview
begin
  _prop_KeyPreview := ReadBool(Data);
end;

procedure THIWin._work_doKeyBack; //!!! KeyPreview
begin
  Back := ToInteger(Data);
end;

procedure THIWin.KeyDown; //!!! KeyPreview
begin
  if _prop_KeyPreview and (FParent <> nil) and Assigned(FParent.OnKeyDown) then
  begin
    FParent.OnKeyDown(FParent, Key, Shift);
    if Key = 0 then exit;
  end;

  Back := -1;
  _onKeyDown(Sender, Key, Shift);  //virtual

   if Back >= 0 then
     Key := Back
   else if Key=0 then
     Back:=0;
end;

procedure THIWin._onKeyDown;
begin
  Sendmessage(Control.Handle, US_KEYDOWN, 0, Key);
end;

procedure THIWin.KeyUp; //!!! KeyPreview
begin
  if _prop_KeyPreview and (FParent <> nil) and Assigned(FParent.OnKeyUp) then
  begin
    FParent.OnKeyUp(FParent, Key, Shift);
    if Key = 0 then exit;
  end;

  Back := -1;
  _onKeyUp(Sender, Key, Shift);  //virtual

  if Back >= 0 then Key := Back;
end;

procedure THIWin._onKeyUp;
begin
  Sendmessage(Control.Handle, US_KEYUP, 0, Key);
end;

procedure THIWin.KeyChar; //!!! KeyPreview
begin
  if _prop_KeyPreview and (FParent <> nil) and Assigned(FParent.OnChar) then
  begin
    FParent.OnChar(FParent, Key, Shift);
    if Key = #0 then exit;
  end;

  if Back <> 0 then
  begin
    Back := -1;
    _onKeyChar(Sender, Key, Shift); //virtual
  end;

  if Back >= 0 then Key := char(Back);
end;

procedure THIWin._onKeyChar; //!!! KeyPreview
begin
  String(chkey) := Key + '';
  Sendmessage(Control.Handle, US_CHAR, 0, LongInt(chkey));
end;

procedure THIWin._onResize;
var
  i: integer;
begin
  inherited;
  Control.Invalidate;
  for i := 0 to Control.ChildCount - 1 do
    Control.Children[i].Invalidate;
  Sendmessage(Control.Handle, US_RESIZE, 0, 0);
end;

initialization
   DoInitCommonControls(ICC_WIN95_CLASSES);
   defHint := THIHintManager.Create;
   defHint.InitByDefault;
   ListOfNameControls := NewStrListEx;

finalization
   ListOfNameControls.free;

end.